import { Injectable } from '@angular/core';
import { Subject } from 'rxjs';

@Injectable()
export class CDialogReference {

  onSave: Subject<any> = new Subject();
  onClose: Subject<any> = new Subject();

  dialogId: string;

  constructor() {
    var date = new Date();
    this.dialogId = "dialog-" + date.getHours() + date.getMinutes() + date.getSeconds() + date.getMilliseconds();
    this.listenForCloseDialog();
  }

  save(data?: any) {
    this.onSave.next(data);
    this.onClose.next(data);
  }

  close(data?: any) {
    this.onClose.next(data);
  }

  private listenForCloseDialog() {
    this.onClose.subscribe(
      res => {
        console.log("removing");
        let dialog = document.getElementById(this.dialogId);
        document.getElementById("cdialog-container").removeChild(dialog);
      }
    )
  }
}