import { NgModule, ModuleWithProviders } from '@angular/core';
import { CDialogComponent } from "./c-dialog/c-dialog.component";
import { CDialogBodyComponent } from "./c-dialog/c-dialog-body/c-dialog-body.component";
import { MaterialButtonComponent } from './other-components/material-button/material-button.component';
import { CommonModule } from '@angular/common';
import { CDialogService } from './c-dialog-services/c-dialog.service';
import { CDialogReference } from './c-dialog-services/c-dialog-reference.service';
import { CDialogData } from './c-dialog-services/c-dialog-data.service';
import { CDialogParameter } from './models/c-dialog-parameter';

@NgModule({
  declarations: [
    CDialogBodyComponent,
    CDialogComponent,
    MaterialButtonComponent
  ],
  imports: [
    CommonModule,
  ],
  entryComponents: [
    CDialogBodyComponent,
    CDialogComponent
  ],
  exports: [
    CDialogBodyComponent,
    MaterialButtonComponent
  ]
})
export class CDialogModule {

  static forRoot(): ModuleWithProviders {
    return {
      ngModule: CDialogModule,
      providers: [CDialogService, CDialogReference, CDialogData, CDialogParameter]
    };
  }
}
